;dbɂdvO telcon.asm for AT90S1200A
;Copyright (C) 2002 T.Sagae

.include "1200def.inc"

;^C}[ĺ10bP(ő255)
.equ	RING_TO_RING	=  25	;RINGo܂ł̕b
;ĂяoḾA1bIE2bIťJԂȂ̂2.5ȏItȂĂяo~Ɣ

.equ	RING_OFF		=  90	;RINGOFF܂ł̃^CAEgb
;ĂяoMRING_OFFȏ㑱ꍇ́uĂ邱vւ̎wł͖Ɣ肷鎞

.equ	RING_NEXT		= 100	;RINGo܂ł̃^CAEgb
;1ڂ̌ĂяoIāA2ڂ̌Ăяoo܂ł̎

.equ	ERROR_WAIT		= 150	;G[畜A܂ł̃^CAEgb
;G[LꍇɎ̎t𖳎鎞

.equ	PULSE_WAIT		=  30	;pXo͂܂ł̕b
;̓dIɁAdIpXo͂܂ł̎

;2񉟂ēdOFF鎞2ڂ̃L[͎t\(KEY_IN_FROM`KEY_IN_TO)
.equ	KEY_IN_FROM		=  10
.equ	KEY_IN_TO		=  20

;|[g̎gprbg`
.equ	RING	= 0	;PD0(in)  ĂяoMop
.equ	SW		= 1	;PD1(in)  L[XCb`op
.equ	PULSE	= 2	;PD2(out) p\Rւ̃pXo͗p
.equ	HOOK	= 3	;PD3(out) tmF̃IttbNp
.equ	SSR		= 4	;PD4(out) ACdON/OFFp
.equ	RING_LED= 5	;PD5(out) ĂяoMo̕\p(fobOmFvp)


;*******************
;* Global variable *
;*******************
.def	ring_timer		= r16	;RINGMĎp
.def	ring_wait_timer	= r17	;RING֘Ã^CAEg`FbNp^C}[
.def	pulse_timer		= r18	;pXo͂܂ł̃^C}[
.def	next_key_timer1	= r19	;
.def	next_key_timer2	= r20	;
.def	wait_counter	= r21	;Ƃwaitpϐ
.def	ring_status		= r22	;RINGMĎp

.def	temp1			= r23	; Work
.def	temp2			= r24	; Work
.def	int_sv_reg		= r25	; 荞݃[`łSREGۑp
.def	int_temp		= r26	; 荞݃[`ł̃[Np


;****************
;* Interruption *
;****************
	rjmp	RESET		; Reset
	reti				; Outside interruption
	rjmp	TIM0_OVF	; Timer/Counter overflow
	reti				; Analog Comparator

RESET:
;******************
;* Initialization *
;******************
	;pb͑Sďo
	ldi		temp1,$0FF
	out		DDRB,temp1

	;pd0,pd1͓
	ldi		temp1,$7C
	out		DDRD,temp1

	;pd0,pd1vAbv
	ldi		temp1,$3
	out		PORTD,temp1

;**** ϐ ****
	ldi		ring_timer,0
	ldi		ring_status,1
	ldi		pulse_timer,0
	ldi		temp1,0
	out		PORTB,temp1

;**** 荞ݏ ****

	; NbN  1/1024w
	ldi		temp1,(1<<CS02)+(1<<CS00)
	out		TCCR0,temp1

	; ***********
;;;	ldi		temp1,(1<<SE)+(1<<SM)
;;;	out		MCUCR,temp1

	; ***********
;;;	ldi		temp1,(1<<INT0)
;;;	out		GIMSK,temp1

	; ^C}[I[o[t[荞݂w
	ldi		temp1,(1<<TOIE0)
	out		TIMSK,temp1

	sei					;荞݋

	;VXe肷܂ŏ҂
	ldi		wait_counter,250	;1JEg1~bx̑҂
	in		temp1,TCNT0
RESET00:
	in		temp2,TCNT0
	cp		temp1, temp2
	breq	RESET00
	in		temp1,TCNT0
	dec		wait_counter
	cpi		wait_counter,0
	brne	RESET00


;**** main ****
main:
	;RINGo
	sbis	PIND,RING
	ldi		ring_timer,RING_TO_RING

	;debug******************
	;ring_timer0ȂRINGMM|[gɏo
	cpi		ring_timer,0
	breq	main00
	sbi		PORTD,RING_LED
main00:
	;debug******************

	;L[͌o
	sbis	PIND,SW
	rcall	SW_ON

	;pulse_timer1ȂpXo͂
	cpi		pulse_timer,1
	brne	main
	;pXo͂
	ldi		pulse_timer,0
	sbi		PORTD,PULSE

	;҂
	ldi		wait_counter,100	;1JEg1~bx̑҂
	in		temp1,TCNT0
main_wait00:
	in		temp2,TCNT0
	cp		temp1, temp2
	breq	main_wait00
	in		temp1,TCNT0
	dec		wait_counter
	cpi		wait_counter,0
	brne	main_wait00

	cbi		PORTD,PULSE
	rjmp	main


;SW͂o
SW_ON:
	;AC ON/OFF𔻒
	sbis	PORTD,SSR
	rjmp	SW_ON2
	;AC ON 
	;2ڂ̃L[͑҂肷
	cpi		next_key_timer2,0
	brne	SW_ON3
	;1ڂ̏ꍇ͎̓͂܂ł̃^C}[ݒ肷
	;2.0bȏ5.0bȓ̓͂Ď
	ldi		next_key_timer1,KEY_IN_FROM
	ldi		next_key_timer2,KEY_IN_TO
	rjmp	SW_ON99
SW_ON3:
	;2ڂ̓͑҂
	;next_key_timer1 ^CAEgĂȂԂł͖̓͂
	cpi		next_key_timer1,0
	breq	SW_ON4
	ldi		next_key_timer2,0
	;`^OƃL[ OFF ҂
	rjmp	SW_ON99

SW_ON4:
	;next_key_timer1 ̎Ԃ͌o߂Ă̂ŏo͂ OFF 
	cbi		PORTD,SSR	;AC OFF
	ldi		next_key_timer2,0
	;`^OƃL[ OFF ҂
	rjmp	SW_ON99

SW_ON2:
	;AC OFF 
	;AC ONAOÑpXo͗p^C}[ݒ肵ďI
	sbi		PORTD,SSR	;AC ON
	ldi		pulse_timer,PULSE_WAIT

	;`^OƃL[ OFF ҂
SW_ON99:
	sbis	PIND,SW
	rjmp	SW_ON99

	;҂
	ldi		wait_counter,50	;1JEg1~bx̑҂
	in		temp1,TCNT0
sw_wait00:
	in		temp2,TCNT0
	cp		temp1, temp2
	breq	sw_wait00
	in		temp1,TCNT0
	dec		wait_counter
	cpi		wait_counter,0
	brne	sw_wait00

	sbis	PIND,SW
	rjmp	SW_ON99
	ret


;********************
;* ^C}[荞 *
;********************
;1MHz/1024  (256-158) JEg
;* 0.1bɊ荞݂
TIM0_OVF:
	in		int_sv_reg,SREG

	ldi		int_temp,158
	out		TCNT0,int_temp


;*** ^C}[JEg_E ***
	cpi		ring_timer,0
	breq	tmskip0
	dec		ring_timer
tmskip0:
	cpi		ring_wait_timer,0
	breq	tmskip1
	dec		ring_wait_timer
tmskip1:
;PULSEɂĂ0,1JEg_E֎~Ƃ
;C[vłpulse_timer1̎PULSEo͂
	cpi		pulse_timer,0
	breq	tmskip2
	cpi		pulse_timer,1
	breq	tmskip2
	dec		pulse_timer
tmskip2:
	cpi		next_key_timer1,0
	breq	tmskip3
	dec		next_key_timer1
tmskip3:
	cpi		next_key_timer2,0
	breq	tmskip4
	dec		next_key_timer2
tmskip4:


	;debug******************
	;ring_timer0ȂRING_LED|[glowɂ
	cpi		ring_timer,0
	brne	tmskip99
	cbi		PORTD,RING_LED
tmskip99:
	;debug******************

	;RING͂L^C}[Đݒ(C[vłĂ邪Ô)
	sbis	PIND,RING
	ldi		ring_timer,RING_TO_RING

	;Ԃɉ
	cpi		ring_status,1
	brne	next_status01
;RING Mo҂̏(1)
	cpi		ring_timer,0
	breq	finish_int			;RING^C}[ĂȂ̂Ŋ荞ݏI
	ldi		ring_status,2		;̏ԂɑJ
	ldi		ring_wait_timer,RING_OFF	;RING̏I҂^C}[ݒ
	rjmp	finish_int

next_status01:
	cpi		ring_status,2
	brne	next_status02
;RING I҂(2)
	cpi		ring_timer,0
	brne	next_status01a
	;RINGÎŎ̏ԂɑJ
	ldi		ring_status,3	;̏ԂɑJ
	ldi		ring_wait_timer,RING_NEXT	;RING̃^C}[ݒ
	rjmp	finish_int
next_status01a:
	;RINGĂ̂Ń^CI[o[ĂȂmF
	cpi		ring_wait_timer,0
	brne	finish_int
	;^CAEgĂ
	ldi		ring_status,99		;G[
	ldi		ring_wait_timer,ERROR_WAIT	;JnĊJ҂̃^C}[ݒ
	rjmp	finish_int

next_status02:
	cpi		ring_status,3
	brne	next_status03
;RINGJn҂(3)
	cpi		ring_timer,0
	breq	next_status02a
	;RINGJn
	ldi		ring_status,4		;̏ԂɑJ
	ldi		ring_wait_timer,RING_OFF	;RING̏I҂^C}[ݒ
	rjmp	finish_int
next_status02a:
	cpi		ring_wait_timer,0
	brne	finish_int
	ldi		ring_status,99		;G[
	ldi		ring_wait_timer,ERROR_WAIT	;JnĊJ҂̃^C}[ݒ
	rjmp	finish_int

next_status03:
	cpi		ring_status,4
	brne	next_status04
;2ڂRING I҂(4)
	cpi		ring_timer,0
	brne	next_status03a
	;RINGÎŗvt

	;AC ONAOÑpXo͗p^C}[ݒ肵ďI
	sbis	PORTD,SSR		;ONĂꍇ̓pXo͂Ȃ
	ldi		pulse_timer,PULSE_WAIT
	sbi		PORTD,SSR	;AC ON
	;OFF HOOK Ԃɂ
	sbi		PORTD,HOOK
	;̓G[ƓԂɂď
	ldi		ring_status,99		;G[
	ldi		ring_wait_timer,ERROR_WAIT	;JnĊJ҂̃^C}[ݒ
	rjmp	finish_int
next_status03a:
	;RINGĂ̂Ń^CI[o[ĂȂmF
	cpi		ring_wait_timer,0
	brne	finish_int
	;^CAEgĂ
	ldi		ring_status,99		;G[
	ldi		ring_wait_timer,ERROR_WAIT	;JnĊJ҂̃^C}[ݒ
	rjmp	finish_int


;G[̍ĊJ҂
next_status04:
	cpi		ring_timer,0
	breq	next_status04a
	ldi		ring_wait_timer,ERROR_WAIT	;JnĊJ҂̃^C}[Đݒ
	rjmp	finish_int
next_status04a:
	;RING͏IĂ̂ōĊJ҂mF
	cpi		ring_wait_timer,0
	brne	finish_int
	ldi		ring_status,1
	;ON HOOK Ԃɂ
	cbi		PORTD,HOOK

finish_int:
	out		SREG,int_sv_reg
	reti
